Index: astman/astman.c
===================================================================
RCS file: /usr/cvsroot/asterisk/astman/astman.c,v
retrieving revision 1.11
diff -u -r1.11 astman.c
--- astman/astman.c	24 Jul 2004 03:52:53 -0000	1.11
+++ astman/astman.c	31 Oct 2004 15:03:55 -0000
@@ -436,7 +436,7 @@
 
 	newtCenteredWindow(60,7, msg);
 
-	inpfield = newtEntry(5, 2, "", 50, &input, 0);
+	inpfield = newtEntry(5, 2, "", 50, (char **)&input, 0);
 	ok = newtButton(22, 3, "OK");
 	cancel = newtButton(32, 3, "Cancel");
 	form = newtForm(NULL, NULL, 0);
@@ -603,8 +603,8 @@
 	ulabel = newtLabel(4,2,"Username:");
 	plabel = newtLabel(4,3,"Password:");
 	
-	username = newtEntry(14, 2, "", 20, &user, 0);
-	password = newtEntry(14, 3, "", 20, &pass, NEWT_FLAG_HIDDEN);
+	username = newtEntry(14, 2, "", 20, (char **)&user, 0);
+	password = newtEntry(14, 3, "", 20, (char **)&pass, NEWT_FLAG_HIDDEN);
 	
 	form = newtForm(NULL, NULL, 0);
 	newtFormAddComponents(form, username, password, login, cancel, label, ulabel, plabel,NULL);
Index: channels/chan_zap.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_zap.c,v
retrieving revision 1.369
diff -u -r1.369 chan_zap.c
--- channels/chan_zap.c	28 Oct 2004 21:42:39 -0000	1.369
+++ channels/chan_zap.c	31 Oct 2004 15:03:55 -0000
@@ -1796,6 +1796,11 @@
 static void destroy_zt_pvt(struct zt_pvt **pvt)
 {
 	struct zt_pvt *p = *pvt;
+	/* Remove channel from the list */
+	if(p->prev)
+		p->prev->next = p->next;
+	if(p->next)
+		p->next->prev = p->prev;
 	ast_mutex_destroy(&p->lock);
 	free(p);
 	*pvt = NULL;
@@ -5529,7 +5534,7 @@
 			   Steve's code */
 			/* Check for callerid, digits, etc */
 			i->hasr2call = 1;
-			chan = zt_new(i, AST_STATE_RING, 0, SUB_REAL, 0);
+			chan = zt_new(i, AST_STATE_RING, 0, SUB_REAL, 0, 0);
 			if (!chan) {
 				ast_log(LOG_WARNING, "Unable to create channel for channel %d\n", i->channel);
 				mfcr2_DropCall(i->r2, NULL, UC_NETWORK_CONGESTION);
Index: pbx/pbx_wilcalu.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx/pbx_wilcalu.c,v
retrieving revision 1.17
diff -u -r1.17 pbx_wilcalu.c
--- pbx/pbx_wilcalu.c	8 Aug 2004 17:15:02 -0000	1.17
+++ pbx/pbx_wilcalu.c	31 Oct 2004 15:03:56 -0000
@@ -82,10 +82,10 @@
 		fds[0].events = POLLIN;
 		poll(fds, 1, -1);
 		bytes=read(fd,buf,256);
-		buf[(int)bytes]=0;
 
 		if(bytes>0){
 			int x;
+			buf[(int)bytes]=0;
 			ast_log(LOG_DEBUG, "WilCalu : Read Buf %s\n",buf);
 			sendbufptr=sendbuf;
 			for(x=0; lastbuf[x]!=0 && x<257; x++);
Index: res/res_odbc.c
===================================================================
RCS file: /usr/cvsroot/asterisk/res/res_odbc.c,v
retrieving revision 1.7
diff -u -r1.7 res_odbc.c
--- res/res_odbc.c	23 Oct 2004 07:03:01 -0000	1.7
+++ res/res_odbc.c	31 Oct 2004 15:03:56 -0000
@@ -351,6 +351,7 @@
 	if ((res != SQL_SUCCESS) && (res != SQL_SUCCESS_WITH_INFO)) {
 		SQLGetDiagRec(SQL_HANDLE_DBC, obj->con, 1, stat, &err, msg, 100, &mlen);
 		SQLFreeHandle(SQL_HANDLE_ENV, obj->env);
+		ast_mutex_unlock(&obj->lock);
 		ast_log(LOG_WARNING, "res_odbc: Error SQLConnect=%d errno=%ld %s\n", res, err, msg);
 		return ODBC_FAIL;
 	} else {
